package Ssm::Common;

=head1 NAME

Ssm::Common - ssm2б ̴ؿ⥸塼

=head2 NOTES

  $Id: Common.pm,v 1.34 2004/10/12 11:36:38 miy Exp $
  Please do 'perldoc -t Ssm::Common' if you get MOJIBAKE.

=head1 SYNOPSIS

  use Ssm::Common;
  &printfile($filepath);

  etc...

  ߥɥ륦SSMѤδܴؿ⥸塼ǤбƤΤ ssm2 Ǥ
  Ȥơץssm2ǻѤޤ

  ؿǤϡssm2ʼ¹ԥեˤѥå main ޤ Ssm::Config ѿѤޤ

=head1 DESCRIPTION

ؤɤδؿϡץssm2Ū˻ѤޤSSM˻ޤϥץȥեǥ⥸塼̾դƸƤӽФȤˤ桼ѤǤؿ⤢ޤ

=cut

use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);

use Carp;
use Exporter;
use AutoLoader qw(AUTOLOAD);
use HTML::TokeParser;
use File::Basename;
use File::Path;
use Jcode;

@ISA = qw(Exporter AutoLoader);
@EXPORT = qw(
);
$VERSION = do {my @r = (q$Revision: 1.34 $ =~ /\d+/g);sprintf "%d."."%02d" x $#r, @r};

1;


=pod

=head2 sub stop_h()(SSMѴؿ)

=over 4

=item 

ʤ1ȤƼưŪ˥ʥ

=item 

ʤ

=item ǽ

Ǥ줿νλ

=back

=cut

sub stop_h {
	my $sig = shift;
	close (HTMLTPL) if (*HTMLTPL);
	close (FILE) if (*FILE);
	die "stop_h called($sig)";
}


__END__
#####  SSM main functional subroutines#########

=pod

=head2 sub ssmerror($msg)(SSMѴؿ)

=over 4

=item 

ʸ1ĤΤߡ

=item 

ʤ

=item ǽ

HTMLإå³ơϤ줿ʸޤHTMLɥȤ򡢥顼åȤƽϤƽλ롣
ѿ $main::debug ʤ顢ǥХåѴؿ &debugprt() ƤӽФϤ˥ǥХåޤ롣

=back

=cut

sub ssmerror($){
	my ($msg) = shift;
	print "Content-Type: text/html; charset=EUC-JP\n\n";
	print "<HTML><BODY BGCOLOR=\"#FFFFFF\">\n";
	print "<H1><FONT COLOR=\"#FF0000\">SSM ERROR</FONT></H1>\n";
	print "<P>".Jcode->new($msg)->euc."</P>\n" if $msg;
	if(${main::debug}){&debugprt();}
	print "<HR><FONT SIZE=\"-1\"><I>SSM ${main::revision}</I></FONT>\n";
	print "</BODY></HTML>\n";
	exit;
}

####################################################

=pod

=head2 sub debugprt()(SSMѴؿ)

=over 4

=item 

ʤ

=item 

ʤ

=item ǽ

SSMѿͤHTMLեޥåȤǽ

=back

=cut

sub debugprt{
	my $format = "<BR>";
	my ($temp);
	print "<H2>main values</H2>\n";
	print "\$ENV{'PATH_INFO'} = $ENV{'PATH_INFO'}${format}\n";
	if ($main::query){
		foreach ($main::query->param){
			print "\$main::query->Vars->{'$_'} = ".$main::query->Vars->{$_}."${format}\n";
		}
	}

	$temp = "\$dir: $main::dir\n";
	$temp .= "\$base: $main::base\n";
	$temp .= "\$ext: $main::ext\n";
	$temp .= "\$htmltpl: $main::htmltpl\n";
	$temp .= "\$funcscr: $main::funcscr\n";

	$temp =~ s/\n/$format\n/go;
	print $temp;

	print "<H2>\$Ssm::Config values inserted in main values</H2>\n";

	$temp = "\$main::prefix: $main::prefix\n";
	$temp .= "\$main::htmldir: $main::htmldir\n";
	$temp .= "\$main::funcdir: $main::funcdir\n";
	$temp .= "\$main::funcext: $main::funcext\n";
	$temp .= "\$main::charset: $main::charset\n";

	$temp =~ s/\n/$format\n/go;
	print $temp;
}

####################################################

=pod

=head2 sub hide_fname($file)(SSMѴؿ)

=over 4

=item 

ե̾򼨤ʸ1ĤΤߡ

=item 

Υե̾ùʥ顼åѡʸ

=item ǽ

ѿ $main::debug ʤե̾ޤʤե̾ޤޤʤ顼åʸ֤

=back

=cut

sub hide_fname($){
	my ($file) = shift;
	my $debug = $main::debug;
	my $msg = "";
	if ($debug){
		$msg = "$file ޤǤ";
	} else {
		$msg = "ꤵ줿ե뤬ޤǤURLǧƤ";
	}
	return $msg;
}

####################################################

=pod

=head2 sub hide_error($errormsg)(SSMѴؿ)

=over 4

=item 

顼åʸ1ĤΤߡ

=item 

ʸùʥ顼åѡʸ

=item ǽ

ѿ $main::debug ʤʸѹˡʤ饨顼äȤΤߤɽʸ֤

=back

=cut

sub hide_error($){
	my ($error) = shift;
	my $debug = $main::debug;
	my $msg = "";
	if ($debug){
		$msg = "$error";
	} else {
		$msg = "ǥ顼ޤ";
	}
	return $msg;
}

####################################################

=pod

=head2 sub errormsg($msg)(SSMѴؿ)

=over 4

=item 

顼åʸ1ĤΤߡ

=item 

ʤ

=item ǽ

ʸHTMLǥ顼åȤƽϤ롣
ʸɤ &pagecodeconv()Ѵ롣

=back

=cut

sub errormsg($){
	my ($msg) = shift;
	print "<H1><FONT COLOR=\"#FF0000\">SSM ERROR</FONT></H1>\n";
	print "<P>".&pagecodeconv($msg)."</P>\n" if $msg;
}

####################################################

=pod

=head2 sub parsehtmlwithfunc()(SSMѴؿ)

=over 4

=item 

HTMLƥץ졼ȥѥ, ץȥեѥ, ꡼֥Ȥؤλ

=item 

ʤ

=item ǽ

SSMμ¹ԥᥤؿ
HTMLƥץ졼Ȥᤷʤ饹ץȤ¹ԡϤ롣

=back

=cut

sub parsehtmlwithfunc($$$){
	my ($htmltpl, $funcscr, $queryref) = @_;
	#ʥϥɥ
	local (%mail::SIG);
	$SIG{'TERM'} = $SIG{'KILL'} = $SIG{'INT'} = \&stop_h;
	$SIG{'CHLD'} = 'IGNORE';

	#
	my $charset = $main::charset||"EUC-JP";
	my ($parser, $textdata, $inssm, $ssmstr, $action, $token, @temp,$mode,$func,$actn,$paramref,$msg,$headflg);
	eval {require "$funcscr";} || return ($headflg, "fail to require $funcscr: $@");
	open (HTMLTPL, "<$htmltpl") || return ($headflg, "fail to open $htmltpl");
	$parser = new HTML::TokeParser( \*HTMLTPL ) or return ($headflg, "fail to new a TokeParser");
	my ($base, $dir, $ext) = fileparse($htmltpl,'\..*');
	while ($token = $parser->get_token()){
		@temp = @$token;
		unless ($token->[0] eq "S" && $token->[1] eq "ssm"){
			if ($token->[0] eq "T"){
				$textdata = $token->[1];
			} else {
				$textdata = $token->[$#temp];
			}
			if ($inssm){
				$ssmstr .= $textdata;
			} else {
				if (!($headflg) and $ext =~ /^\.html?$/i and $textdata !~ /^(\s)*$/){
					print "Content-Type: text/html; charset=$charset\n\n";
					$headflg = 1;
				}
				($headflg || $textdata !~ /^(\s)*$/ ) and print "$textdata";
			}
		} else {
			#ˤ뤳ȤΰŤ
			$mode = $token->[2]->{'mode'};
			if ($mode eq "begin"){
				$paramref = $token->[2];
				$func = $paramref->{'function'};
				$inssm = 1;
			} else { #$mode = "end" λ
				if ($func) {
					if ($func !~ /::/){
						$func = &getpackagename($funcscr)."::".$func if (&getpackagename($funcscr));
					}
					eval("\&$func(\$ssmstr, \$queryref, \$paramref)") or $msg .= "$func, ";
				} else { #functionλ̵꤬ϡץ
					print $ssmstr;
				}
				$inssm = 0;
				$ssmstr = "";
				$mode = "";
				$func = "";
			}
		}
	}
	close (HTMLTPL);
	return ($headflg, $msg);
}

####################################################

=pod

=head2 sub getpackagename($script_file)(SSMѴؿ)

=over 4

=item ǽ

ץȥեѥꡢΥץȤΥѥå֤̾

=item 

ץȥեѥɽʸ

=item 

  ѥå̾ʸ
  ѥå̾Ǥʤϡ0

=back

=cut

sub getpackagename($){
	my ($filename) = shift;
	#ʥϥɥ
	local (%mail::SIG);
	$SIG{'TERM'} = $SIG{'KILL'} = $SIG{'INT'} = \&stop_h;

	my ($name);
	unless (open (FILE, "<$filename")){
		return 0;
	} else {
		while (<FILE>){
			if (/^package\s+([:\w]*)\s*;$/){
				$name = $1;
				last;
			}
		}
		close (FILE);
		return ($name)?$name:0;
	}
}

####################################################

=pod

=head2 sub ssmprintfile()

=over 4

=item 

SSMǶޤ줿ʸ, ꡼֥Ȥؤλ, SSM°ͤäϥåؤλ

=item 

1,Ԥξ0

=item ǽ

SSM°ȤƥեѥХѥˤȽϥեޥåȤꡢեƤϤ롣

=item 

  <SSM MODE="begin" FUNCTION="Ssm::Common::ssmprintfile" FILE="/data/somefile.html" FORMAT="html">
  <SSM MODE="end">

=item եޥå

=over 4

=item html

եȤHTMLեޥåȤȤư
ĤޤꡢΥƥƥؤѴԤʤ

=item 嵭ʳ

եȤ򤽤Τޤɽ롣
ĤޤꡢHTML򥨥ƥƥѴ롣

=back

եޥåɽ Case Insensitive

=back

=cut

sub ssmprintfile($$$){
	my ($ssmstr, $queryref, $paramref) = @_;
	my ($filename) = $paramref->{'file'};
	my ($format) = $paramref->{'format'};
	return &printfile($filename,$format);
}

####################################################

=pod

=head2 sub printfile($filename,$format)(SSMѴؿ)

=over 4

=item 

եѥХѥˤɽʸ, եޥåȤɽʸ

=item 

1,Ԥξ0

=item ǽ

եѥХѥˤȽϥեޥåȤꡢեƤϤ롣

=item եޥå

=over 4

=item html

եȤHTMLեޥåȤȤư
ĤޤꡢΥƥƥؤѴԤʤ

=item 嵭ʳ

եȤ򤽤Τޤɽ롣
ĤޤꡢHTML򥨥ƥƥѴ롣

=back

եޥåɽ Case Insensitive

=back

=cut

sub printfile($$){
	my ($filename,$format) = @_;
	my ($contents);
	#ʥϥɥ
	local (%mail::SIG);
	$SIG{'TERM'} = $SIG{'KILL'} = $SIG{'INT'} = \&stop_h;

	open (FILE, "<$filename") or return 0;
		
	if ($format && $format =~ /^html$/i){
		while (<FILE>){
			print $_;
		}
	} else {
		while (<FILE>){
			$contents .= $_;
		}
		print &text2html($contents);
	}
	close (FILE);
	return 1;
}

####################################################

=pod

=head2 sub printvalue()

=over 4

=item 

SSMǶޤ줿ʸ, ꡼֥Ȥؤλ, SSM°ͤäϥåؤλ

=item 

1

=item ǽ

줿꡼ƤSSMǶʸν񼰤ǽϤ롣

ACTION°ʣͤĥ꡼ѿη֤Ǥ롣

RESULTVALUE°ꤹȡɸϤؤ print Ǥʤ
̾ __(ꤵ줿ʸ)__ Υѿ˷̽ϤǼ롣
̾ϡꤵ줿ʸ˥2Ĥġ

=item 

  <TABLE BORDER="1">
  <TR><TH>key</TH><TH>value</TH></TR>

  <SSM ACTION="allpair" FUNCTION="Ssm::Common::printvalue" MODE="begin">
  <TR><TD>%_key_%</TD><TD>%_value_%</TD></TR>
  <SSM MODE="end">

  </TABLE>

=item ǤACTIONμ

=over 2

=item allpairʥǥեȡ

  ꡼Ƥkey=valueΥڥɽ롣
  ƱkeyʣvalueϡޤǶڤ롣
  SSMǶʸ %_key_%  keyˡ%_value_% valueִ롣
  Ƥkeyʬִ򤷤ʤSSMǶޤ줿ʸ򷫤֤ɽ롣
  %_key_%  %_value_%  Case sensitive
  ACTIONꤵʤäallpairȲᤵ롣

=over 2



  <TABLE BORDER="1">
  <TR><TH>key</TH><TH>value</TH></TR>

  <SSM MODE="begin" FUNCTION="Ssm::Common::printvalue" ACTION="allpair">
  <TR><TD>%_key_%</TD><TD>%_value_%</TD></TR>
  <SSM MODE="end">

  </TABLE>

=back

=item once

  ꤷkeyͤɽ롣
  SSMǶʸ %_(key̾)_% value֤롣
  ƱkeyʣvalueϡޤǶڤ롣
  SSMǶޤ줿ʸ򷫤֤ɽʤΤ allpair Ȥΰ㤤
  %_(key̾)_%  Case sensitive

=over 2



  <TABLE BORDER="1">
  <TR><TH>ͤޤȤɽ</TH></TR>

  <SSM MODE="begin" FUNCTION="Ssm::Common::printvalue" ACTION="once">
  <TR>
  <TD>
  aaaccc:%_aaa_%ӡ%_ccc_%<BR>
  ddd:%_ddd_%
  </TD>
  </TR>

  <SSM MODE="end">

  </TABLE>

=back

=item first

  ꤷkeyͤɽ롣
  SSMǶʸ %_(key̾)_% value֤롣
  ƱkeyʣvalueϡǽͤΤɽ롣
  â֤ϸꤵƤʤ
  ƤkeyˤĤơvalue줾ĤĤʤȤݾڤ硢once Ʊ
  %_(key̾)_%  Case sensitive

=over 2



  <TABLE BORDER="1">
  <TR><TH>key</TH><TH>value</TH></TR>

  <SSM MODE="begin" FUNCTION="Ssm::Common::printvalue" ACTION="first">
  <TR><TD>aaa</TD><TD>%_aaa_%</TD></TR>
  <TR><TD>ccc</TD><TD>%_ccc_%</TD></TR>
  <SSM MODE="end">

  </TABLE>

=back

=item roop

  ꤷkeyͤɽ롣
  SSMǶʸ %_(key̾)_% value֤롣
  ƱkeyʣvalueϡָĿ¿keyvalue
  ɽڤޤǡִ򤷤ʤSSMǶޤ줿ʸ򷫤֤ɽ롣
  %_(key̾)_%  Case sensitive

=over 2



  <TABLE BORDER="1">
  <TR><TH>value</TH></TR>

  <SSM ACTION="roop" FUNCTION="Ssm::Common::printvalue" MODE="begin">
  <TR><TD>%_ccc_%</TD></TR>
  <SSM MODE="end">

  </TABLE>

=back

=back

=back

=cut

sub printvalue($$$){
	my ($ssmstr, $queryref, $paramref) = @_;
	my (%values, $action, $key,$tmpstr, @tempval,$c, $max,@target, $res);
	%values = $$queryref->Vars;
	$action = $paramref->{'action'};
	if (defined $paramref->{'resultvalue'} && $paramref->{'resultvalue'} =~ /^\w+$/){
		$res = "__$paramref->{'resultvalue'}__";
	}
	if ($action =~ /^(roop)|(first)|(once)$/i){
		@target = ($ssmstr =~ m#%_(\w+)_%#gm);
		$c = 0;
		$max = 1;
		while ($max > $c && @target){
			$tmpstr = $ssmstr;
			foreach $key (@target){
				@tempval = ();
				if (defined($values{$key})){
					@tempval = split(/\0/,$values{$key});
				} else {
					$tempval[$c] = ""; # c=0λʤ
				}
				if ($action =~ /^once$/i){
					$tmpstr =~ s/%_${key}_%/join(",",@tempval)/eg;
				} else {
					$tmpstr =~ s/%_${key}_%/$tempval[$c]/g;
				}
				$max = $#tempval+1 if ($#tempval >= $max && $action =~ /^roop$/i);
			}
			if ($res){
				$$queryref->Vars->{$res} .= $tmpstr
			} else {
				print $tmpstr;
			}
			$c++;
		}
	} else { # action=allpair ǥե
		foreach $key (keys %values){
			$tmpstr = $ssmstr;
			$values{$key} =~ s/\0/,/g;
			$tmpstr =~ s/%_key_%/$key/g;
			$tmpstr =~ s/%_value_%/$values{$key}/g;
			if ($res){
				$$queryref->Vars->{$res} .= $tmpstr
			} else {
				print $tmpstr;
			}
		}
	}
	return 1;
}

####################################################

=pod

=head2 sub parse_selected()

=over 4

=item 

SSMǶޤ줿ʸ, ꡼֥Ȥؤλ, SSM°ͤäϥåؤλ

=item 

1

=item ǽ

SSMǶʸ˥쥯ʥץꥹȡˡåܥåޤϥ饸ܥINPUTΤ줫ä顢꡼줿ͤǥեȤͤȤ򤵤줿֤HTMLϤ롣

RESULTVALUE°ꤹȡɸϤؤ print Ǥʤ
̾ __(ꤵ줿ʸ)__ Υѿ˷̽ϤǼ롣
̾ϡꤵ줿ʸ˥2Ĥġ

SSMǶʸˤϡ֤򼨤ʸ񤭽Ф֤ %_(key̾)_% ȤʸɽƤ

㤨С

  <SELECT NAME="ccc" MULTIPLE SIZE="3">
  <OPTION VALUE="ddd" %_ccc_%>ddd
  <OPTION VALUE="eee" %_ccc_%>eee
  <OPTION VALUE="fff" %_ccc_%>fff
  </SELECT>

ȵҤСVALUEͤ줿硢%_ccc_%  selected ִ롣

VALUE°ϾάǤʤĤޤꡢ

  <OPTION>ddd
  <OPTION>eee
  <OPTION>fff

ϡκݤˤư뤬֤ǥեȤɽϡʲɽԲġ

  <OPTION %_ccc_%>ddd
  <OPTION %_ccc_%>eee
  <OPTION %_ccc_%>fff

=item ¾

=over 2

=item åܥåξ

  <INPUT TYPE="checkbox" NAME="ddd" value="value-of-ddd" %_ddd_%>

=item 饸ܥξ

  <INPUT TYPE="radio" NAME="ddd" VALUE="value1" %_ddd_%>
  <INPUT TYPE="radio" NAME="ddd" VALUE="value2" %_ddd_%>

=back

=back

=cut

sub parse_selected($$$){
	my ($ssmstr, $queryref, $paramref) = @_;
	my (%values,$inselect,$selectname,@temp, $parser, $token, $posted, $found, $res);
	%values = $$queryref->Vars;
	if (defined $paramref->{'resultvalue'} && $paramref->{'resultvalue'} =~ /^\w+$/){
		$res = "__$paramref->{'resultvalue'}__";
	}

	$parser = new HTML::TokeParser( \$ssmstr ) or return 0;
	while ($token = $parser->get_token()){
		@temp = @$token;
		if ($token->[0] eq "S" && $token->[1] eq "select"){
			$inselect = 1;
			$selectname = $token->[2]->{'name'};
			if ($res){
				$$queryref->Vars->{$res} .= $token->[$#temp];
			} else {
				print $token->[$#temp];
			}
		}
		elsif ($token->[0] eq "E" && $token->[1] eq "select"){
			$inselect = 0;
			$selectname = "";
			if ($res){
				$$queryref->Vars->{$res} .= $token->[$#temp];
			} else {
				print $token->[$#temp];
			}
		}
		elsif ($token->[0] eq "S" && $token->[1] eq "option" && $inselect){
			if ($token->[2]->{'%_'.$selectname.'_%'}){
				$found = 0;
				if (defined($values{$selectname})){
					IFPOSTED:foreach $posted (split(/\0/,$values{$selectname})){
						if ($token->[2]->{'value'} eq $posted){
							$token->[$#temp] =~ s#%_${selectname}_%#selected#i;
							$found = 1;
							last IFPOSTED;
						}
					}
				}
				$token->[$#temp] =~ s#%_${selectname}_%##i unless $found;
			}
			if ($res){
				$$queryref->Vars->{$res} .= $token->[$#temp];
			} else {
				print $token->[$#temp];
			}
		}
		elsif ($token->[0] eq "S" && $token->[1] eq "input" && $token->[2]->{'type'} eq "radio"){
			if (defined($token->[2]->{'%_'.$token->[2]->{'name'}.'_%'})){
				if (defined($values{$token->[2]->{'name'}}) && $token->[2]->{'value'} eq $values{$token->[2]->{'name'}}){
					$token->[$#temp] =~ s#%_$token->[2]->{'name'}_%#checked#i;
				} else {
					$token->[$#temp] =~ s#%_$token->[2]->{'name'}_%##i;
				}
			}
			if ($res){
				$$queryref->Vars->{$res} .= $token->[$#temp];
			} else {
				print $token->[$#temp];
			}
		}
		elsif ($token->[0] eq "S" && $token->[1] eq "input" && $token->[2]->{'type'} eq "checkbox"){
			if (defined($token->[2]->{'%_'.$token->[2]->{'name'}.'_%'})){
				$found = 0;
				if (defined($values{$token->[2]->{'name'}})){
					IFPOSTED:foreach $posted (split(/\0/,$values{$token->[2]->{'name'}})){
						if ($token->[2]->{'value'} eq $posted){
							$token->[$#temp] =~ s#%_$token->[2]->{'name'}_%#checked#i;
							$found = 1;
							last IFPOSTED;
						}
					}
				}
				$token->[$#temp] =~ s#%_$token->[2]->{'name'}_%##i unless $found;
			}
			if ($res){
				$$queryref->Vars->{$res} .= $token->[$#temp];
			} else {
				print $token->[$#temp];
			}
		}
		elsif ($token->[0] eq "T"){
			if ($res){
				$$queryref->Vars->{$res} .= $token->[1];
			} else {
				print $token->[1];
			}
		} else {
			if ($res){
				$$queryref->Vars->{$res} .= $token->[$#temp];
			} else {
				print $token->[$#temp];
			}
		}
	}
	return 1;
}

####################################################

=pod

=head2 sub checkandmkdir($file)(SSMѴؿ)

=over 4

=item 

եѥХѥˤɽʸ

=item ǽ

ǻꤵ줿եǼǥ쥯ȥ̵꤬кߤ롣

=item 

塢ǥ쥯ȥ꤬¸ߤ1,¸ߤʤ0

=back

=cut

sub checkandmkdir($){
	my $dir = dirname(shift);
	(-d $dir) || eval{mkpath($dir);};
	return (-d $dir)?1:0;
}

####################################################

=pod

=head2 sub retzeroinerror($ref_to_msg, $errormsg)(SSMѴؿ)

=over 4

=item 

åǼ륹顼Υե, åʸ

=item 

0

=item ǽ

2ʸ1ǻȤƤ륹顼˳Ǽ0֤

=back

=cut

sub retzeroinerror($$){
	my ($msgref, $msg) = @_;
	$$msgref = $msg;
	return 0;
}	

#####  HTML and TEXT related subroutines section

=pod

=head2 sub text2html()

=over 4

=item 

Ѵоʸ, Pղåץ

2ɬܡͤꤹȡ2ĤǶڤ줿ѥ饰դ'<P>'ǰϤࡣ

=item 

ʸ

=item ǽ

Ϥ줿ʸHTMLüʸ򥨥ƥƥѴѴʸΤ֤
SSMִɤ'%'⥨ƥƥѴ롣
֤ '&nbsp;&nbsp;&nbsp;&nbsp;' Ѵ롣
ʣ³ȾѥڡϡȾѥڡ1Ĥ '&nbsp;' Ѵ롣
2ͤꤹȡ2ĤǶڤ줿ѥ饰դ'<P>'ǰϤࡣ
ĤäԤ'<BR>'Ѵ롣

=back

=cut

sub text2html($;$){
	my $string = &text4textarea(shift);
	($string) or return $string;
	my ($i, @paras, @br, $addp);
	$addp = shift;

	$string =~ s/\t/\&nbsp;\&nbsp;\&nbsp;\&nbsp;/g;
	$string =~ s/ (?= )/\&nbsp;/g;
	$string =~ s/\&nbsp; /\&nbsp;\&nbsp;/g;

	@paras = split(/(?:\r?\n){2}/, $string);

	if ((scalar @paras) > 1 && $addp){
		PARAS:foreach ($i=0; $i<=$#paras; $i++){
			unless ($paras[$i]){
				$paras[$i] = "<BR>\n" x 2;
				next PARAS;
			}
			@br = ($paras[$i] =~ /^((?:\r?\n)*).*?((?:\r?\n)*)$/);
			$paras[$i] =~ s/^((?:\r?\n)*)//;
			$paras[$i] =~ s/((?:\r?\n)*)$//;
			$paras[$i] = '<P>'.$paras[$i].'</P>';
			$paras[$i] = ('<BR>' x length($br[0])).$paras[$i] if $br[0];
			$paras[$i] .= '<BR>' x length($br[1]) if ($br[1] && $i != $#paras);
			$paras[$i] =~ s/\r?\n/<BR>/g;
		}
		return join('', @paras);
	} else {
		$string =~ s/\r?\n/<BR>/g;
		return $string;
	}
}


####################################################

=pod

=head2 sub text4textarea()

=over 4

=item 

ʸ1ĤΤߡ

=item 

ʸ

=item ǽ

Ϥ줿ʸHTMLüʸ򥨥ƥƥѴѴʸΤ֤
SSMִɤ'%'⥨ƥƥѴ롣
֤Ⱦѥڡ&nbsp;Ѵʤ
(\n)'<BR>'Ѵʤ
<TEXTAREA>ɽʸѴꡣ

=back

=cut

sub text4textarea($){
	my $string = shift;
	if ($string){
		$string =~ s/\&/\&amp;/g;
		$string =~ s/#/\&#35;/g;
		$string =~ s/</\&lt;/g;
		$string =~ s/>/\&gt;/g;
		$string =~ s/"/\&quot;/g;
		$string =~ s/'/\&#39;/g;
		$string =~ s/%/\&#37;/g;
	}
	return $string;
}

####################################################

=pod

=head2 sub pagecodeconv($string)(SSMѴؿ)

=over 4

=item 

ʸ1ĤΤߡ

=item 

ʸ

=item ǽ

Ϥ줿ʸΥ󥳡 $main::charset ǻꤵ줿󥳡ɤѴѴʸ֤
$main::charset ꤵƤʤ EUC-JP Ѵ롣

=back

=cut

sub pagecodeconv($){
	my $charset = $main::charset||"EUC-JP";
	return &codeconv(shift, $charset);
}
	
####################################################

=pod

=head2 sub mailcodeconv($string)(SSMѴؿ)

=over 4

=item 

ʸ1ĤΤߡ

=item 

ʸ

=item ǽ

Ϥ줿ʸΥ󥳡 $Ssm::Config::mailencoding ǻꤵ줿󥳡ɤѴѴʸ֤
$Ssm::Config::mailencoding ꤵƤʤ JIS Ѵ롣

=back

=cut

sub mailcodeconv($){
	my $charset = $Ssm::Config::mailencoding||"JIS";
	return &codeconv(shift, $charset);
}
	
####################################################

=pod

=head2 sub codeconv($string,$charset)(SSMѴؿ)

=over 4

=item 

ʸ,󥳡

=item 

ʸ

=item ǽ

1ʸ2ʸǻꤵ줿󥳡ѴѴʸ֤

=back

=cut

sub codeconv($$){
	my ($string,$charset) = @_;
	chomp $charset;
	my $code;
	if ($charset =~ /(SHIFT[_-]JIS)|(x[_-]sjis)/i){
		$code = "sjis";
	} elsif ($charset =~ /EUC/i){
		$code = "euc";
	} elsif ($charset =~ /(JIS)|(ISO[_-]2022[_-]JP)/i){
		$code = "jis";
	} elsif ($charset =~ /(Unicode)|(UTF[_-]8)/i){
		$code = "utf8";
	} else {
		$code = "euc";
	}
	$string = eval("Jcode->new(\$string)->$code") if $string;
	return $string;
}

####################################################

=pod

=head2 sub conv4transsubmit($string) ʸŤ

=over 4

=item 

ʸ1ĤΤߡ

=item 

ʸ

=item ǽ

Ϥ줿ʸ >, <, ", ' ̤ʸѴѴʸΤ֤
եˤϤhiddenܤȤƺ뤿Ѵؿ

text4textarea() ؿˤꡢפȤʤ롣
ƱŪΤˤ text4textarea() λѤ侩

=back

=cut

sub conv4transsubmit($){
	my $string = shift;
	if ($string){
		$string =~ s/</__LEFTTAG__/g;
		$string =~ s/>/__RIGHTTAG__/g;
		$string =~ s/"/__DQUOT__/g;
		$string =~ s/'/__SQUOT__/g;
	}
	return $string;
}

####################################################

=pod

=head2 sub reconv4transsubmit($string) ʸŤ

=over 4

=item 

ʸ1ĤΤߡ

=item 

ʸ

=item ǽ

conv4transsubmit()εդѴԤ

conv4transsubmit()  text4textarea() ѤȡפȤʤ롣

=back

=cut

sub reconv4transsubmit($){
	my $string = shift;
	if ($string){
		$string =~ s/__LEFTTAG__/</g;
		$string =~ s/__RIGHTTAG__/>/g;
		$string =~ s/__DQUOT__/"/g;
		$string =~ s/__SQUOT__/'/g;
	}
	return $string;
}

####################################################

=pod

=head2 sub go_and_exit($$)

=over 4

=item 

HTMLƥץ졼ȥѥ, ꡼֥Ȥؤλ

=item 

1

=item ǽ

Ǥ̥ե롣
̥ǥ쥯ȥΥեꤹϡ$ENV{'PATH_INFO'}ʬ򥹥å夫ꤹ롣

=back

=cut

sub go_and_exit($$){
	my ($html, $queryref) = @_;
	my ($retfuncbase, $dir, $ext);
	if ($html =~ m#^/# ) {
		($retfuncbase, $dir, $ext) = fileparse($html, '\.(cgi|html?)');
		$html = $retfuncbase.$ext;
		$main::dir = $dir;
	} else {
		$retfuncbase = $html;	
		$retfuncbase =~ s/^(\w+)\.\w+/$1/;
	}
	my $htmltpl = $main::prefix.$main::dir.$main::htmldir."/".$html;
	my $funcscr = $main::prefix.$main::dir.$main::funcdir."/".$retfuncbase.".pl";
	&parsehtmlwithfunc($htmltpl, $funcscr, $queryref);
	exit 1;
}


=head1 AUTHOR

  Miyabiko INOUE <miy@web-ware.org>
  ХθϢ mailto:miy@web-ware.org ޤǤꤤޤ

=head1 COPYRIGHT

  Copyright (c) Miyabiko INOUE <miy@web-ware.org>.
  All rights reserved.

  Υ⥸塼̵ǤѤޤ
  ѡۤʤɤλѵ˴ؤƤϡPerl  Artistic License ŬѤޤ

  This program is free software; you can redistribute it
  and/or modify it under Perl Artistic License.

=head1 NOTES

  Further information: http://www.web-ware.org/

=head1 SEE ALSO

perl(1).

=cut


1;
